//
//  VODUploadDemo.m
//  VODUploadDemo
//
//  Created by Leigang on 16/4/19.
//
//

#import "VODUploadDemo.h"
#import <VODUpload/VODUploadClient.h>
#import <VODUpload/VODUpload.h>

static NSString* const testAccessKeyId = @"<accessKeyId>";
static NSString* const testAccessKeySecret = @"<accessKeySecret>";
static NSString* const testSecretToken = @"";
static NSString* const testExpireTime = @"";

static VODUploadClient * m;
static NSString * const endpoint = @"<endpoint>";
static NSString * const bucketName = @"<bucket>";
static NSString * tempFilePath=@"";
static NSString * tempFilePath2=@"";
static NSString * fileKey = @"1.ios.mp4";
static int fileSize = 1024000;


VODUploadClient *upload;

@implementation VODUploadDemo

// upload file
- (void)uploadFile {
    
    tempFilePath = [self createTempFile:@"temp_file_test" fileSize:fileSize*5];
    tempFilePath2 = [self createTempFile:@"temp_file_test2" fileSize:fileSize*10];
    
    // callback functions.
    OnUploadSucceedListener testSuccessCallbackFunc = ^(NSString* filePath){
        NSLog(@"manager: upload success!");
    };
    
    OnUploadFailedListener testFailedCallbackFunc = ^(NSString* filePath, long code, NSString* message){
        NSLog(@"manager: failed code = %li, error message = %@", code, message);
        if(code == 1006) {
            // user cancel, do something...
        }
    };
    
    OnUploadProgressListener testProgressCallbackFunc = ^(NSString* filePath, long uploadedSize, long totalSize) {
        NSLog(@"manager: during progress uploadedSize : %li, totalSize : %li", uploadedSize, totalSize);
    };
    
    OnUploadTokenExpiredListener testTokenExpiredCallbackFunc = ^{
        NSLog(@"manager: token expired.");
    };
    
    [upload init:testAccessKeyId accessKeySecret:testAccessKeySecret secretToken:testSecretToken expireTime:testExpireTime onUploadSucceed:testSuccessCallbackFunc onUploadFailed:testFailedCallbackFunc onUploadProgress:testProgressCallbackFunc onUploadTokenExpired:testTokenExpiredCallbackFunc];
    
    [upload addFile:tempFilePath endpoint:endpoint bucket:bucketName object:fileKey];
    [upload addFile:tempFilePath2 endpoint:endpoint bucket:bucketName object:fileKey];
    [upload startUpload];
}

#pragma mark - temp_file
// create a file with size of fileSize in the fixed path, and return the file path.
- (NSString *)createTempFile : (NSString * ) fileName fileSize : (int) size {
    NSString * tempFileDirectory;
    NSString * path = NSHomeDirectory();
    tempFileDirectory = [NSString stringWithFormat:@"%@/%@/%@", path, @"tmp", fileName];
    //NSLog(@"%@", tempFileDirectory);
    NSFileManager * fm = [NSFileManager defaultManager];
    
    if ([fm fileExistsAtPath:tempFileDirectory]){
        [fm removeItemAtPath:tempFileDirectory error:nil];
    }
    
    [fm createFileAtPath:tempFileDirectory contents:nil attributes:nil];
    NSFileHandle * fh = [NSFileHandle fileHandleForWritingAtPath:tempFileDirectory];
    NSMutableData * basePart = [NSMutableData dataWithCapacity:size];
    for (int i = 0; i < size/4; i++) {
        u_int32_t randomBit = arc4random();
        [basePart appendBytes:(void*)&randomBit length:4];
    }
    [fh writeData:basePart];
    [fh closeFile];
    return tempFileDirectory;
}

- (void)runDemo {
    NSLog(@"VODUpload demo.");
    upload = [[VODUploadClient alloc] init];
    [self uploadFile];
}

@end
